/* .MiK. SoftWare

  Multilingual Terminal Emulator "MTR".

 Copyright (C) 2000 Mike I. Kozin. ALL RIGHT RESERVED
 
 On Base "MuTerminal"
 Copyright (C) 1998,99 Kazuho Okui and Takashi Murai. ALL RIGHT RESERVED
  
 This file is part of MTR.

 MTR is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 libmtr.cpp,v 0.1 26-Sep-2000
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <InterfaceKit.h>
#include <Roster.h>
#include <app/Application.h>

#if B_BEOS_VERSION >= 0x0450
#include <bsd_mem.h>
#endif

#include "mtr.h"
////////////////////////////////////////////////////////////////////////////
//
//
////////////////////////////////////////////////////////////////////////////
int
get_coding()
{
  BList tmpList;
  int32 i, n, coding = 0;
  team_id theTeam;
  char *send_dev;
  const char *recv_dev;

  send_dev = getenv("TTY");
  send_dev += 8;

  be_roster->GetAppList(MTR_SIGNATURE, &tmpList);

  n = tmpList.CountItems ();
  
  for (i = 0; i < n; ++i){
    theTeam = (team_id) tmpList.ItemAt(i);

	BMessage message, reply; 
	BMessenger mt(MTR_SIGNATURE, theTeam);
	/*
	 * Get MTR tty
	 */
	message.what = B_GET_PROPERTY; 
	message.AddSpecifier("tty"); 
	message.AddSpecifier("Window", (int32)0); 

	mt.SendMessage(&message, &reply); 

	recv_dev = reply.FindString ("result");

	if (bcmp (recv_dev, send_dev, 2) == 0) {
	  /*
	   * Get coding from window .
	   */
       message.MakeEmpty();
       message.what = B_GET_PROPERTY; 
       message.AddSpecifier("encode"); 
       message.AddSpecifier("Window", (int32)0); 
       mt.SendMessage(&message, &reply); 
       uint32 op = reply.FindInt32 ("result");

       const etable *p = encoding_table;
       while(p->name){
	    if ( p->op == op) {
	      return coding;
	    }
	    p++;
	    coding++;
	  }
	}
  }
  return -1;
}
////////////////////////////////////////////////////////////////////////////
//
//
////////////////////////////////////////////////////////////////////////////
int  
set_coding (int32 coding)
{
  BList tmpList;
  int i, n;
  char *send_dev;
  const char *recv_dev;
  team_id theTeam;

  send_dev = getenv("TTY");
  send_dev += 8;

  be_roster->GetAppList(MTR_SIGNATURE, &tmpList);

  n = tmpList.CountItems ();
  
  for (i = 0; i < n; ++i){
    theTeam = (team_id) tmpList.ItemAt(i);
	/*
	 * Find App is MTR.
	 */

	BMessage message, reply; 
	BMessenger mt(MTR_SIGNATURE, theTeam);
	/*
	 * Get MTR Window Title string
	 */
	message.what = B_GET_PROPERTY; 
	message.AddSpecifier("tty"); 
	message.AddSpecifier("Window", (int32)0); 
	// find window and get window title
	BMessenger aWin; 
	mt.SendMessage(&message, &reply); 
	
	recv_dev = reply.FindString ("result");

	if (bcmp (recv_dev, send_dev, 2) == 0) {
	  /*
	   * Get first window specify
	   */
	  message.MakeEmpty();
	  message.what = B_SET_PROPERTY;
	  message.AddInt32("data", coding);
	  message.AddSpecifier("encode"); 
	  message.AddSpecifier ("Window", (int32) 0);
	  mt.SendMessage (&message, &reply);
	  return 0;
	}
  }
  return 1;
}

////////////////////////////////////////////////////////////////////////////
// check_mtr ()
//	Check terminal whether MTR.
////////////////////////////////////////////////////////////////////////////
int
check_mtr (void)
{
  BList tmpList;
  int32 i, n;
  team_id theTeam;
  char *send_dev;
  const char *recv_dev;

  send_dev = getenv("TTY");
  send_dev += 8;

  be_roster->GetAppList(MTR_SIGNATURE, &tmpList);

  n = tmpList.CountItems ();
  
  for (i = 0; i < n; ++i){
    theTeam = (team_id) tmpList.ItemAt(i);

	BMessage message, reply; 
	BMessenger mt(MTR_SIGNATURE, theTeam);
	/*
	 * Get MuTerminal tty
	 */
	message.what = B_GET_PROPERTY; 
	message.AddSpecifier("tty"); 
	message.AddSpecifier("Window", (int32)0); 

	mt.SendMessage(&message, &reply); 

	recv_dev = reply.FindString ("result");

	if (bcmp (recv_dev, send_dev, 2) == 0)
	  return 0;
  }
  return -1;
}

